/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _GROUP_OPTIONS_H
#define _GROUP_OPTIONS_H

#include <core/core.h>

class GroupOptions : public CompOption::Class {
    public:
        enum Options {
            SelectButton,
            SelectSingleKey,
            GroupKey,
            UngroupKey,
            RemoveKey,
            CloseKey,
            IgnoreKey,
            TabmodeKey,
            ChangeTabLeftKey,
            ChangeTabRightKey,
            ChangeColorKey,
            MoveAll,
            ResizeAll,
            RaiseAll,
            MaximizeUnmaximizeAll,
            MinimizeAll,
            ShadeAll,
            AutoGroup,
            AutoUngroup,
            WindowMatch,
            SelectOpacity,
            SelectSaturation,
            SelectBrightness,
            SelectPrecision,
            FillColor,
            LineColor,
            Mipmaps,
            UntabOnClose,
            AutotabCreate,
            AutotabWindows,
            TabbarShowDelay,
            TabbingSpeed,
            TabbingTimestep,
            FadeTime,
            PulseTime,
            ReflexTime,
            FadeTextTime,
            VisibilityTime,
            ChangeAnimationTime,
            BarAnimations,
            ThumbSize,
            ThumbSpace,
            BorderRadius,
            BorderWidth,
            TabBaseColor,
            TabBorderColor,
            TabHighlightColor,
            TabStyle,
            TabbarFontSize,
            TabbarFontColor,
            DndUngroupWindow,
            DragHoverTime,
            DragSpringK,
            DragFriction,
            DragYDistance,
            DragSpeedLimit,
            Glow,
            GlowSize,
            GlowType,
            OptionNum
        };

        enum TabStyle {
            TabStyleSimple = 0,
            TabStyleGradient = 1,
            TabStyleGlass = 2,
            TabStyleMetal = 3,
            TabStyleMurrina = 4,
        };

        enum GlowType {
            GlowTypeRectangularGlow = 0,
            GlowTypeGlowRing = 1,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        GroupOptions ();
        virtual ~GroupOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetSelectButton ();
        void optionSetSelectButtonInitiate (CompAction::CallBack init);
        void optionSetSelectButtonTerminate (CompAction::CallBack term);
        void optionSetSelectButtonNotify (ChangeNotify notify);

        CompAction & optionGetSelectSingleKey ();
        void optionSetSelectSingleKeyInitiate (CompAction::CallBack init);
        void optionSetSelectSingleKeyTerminate (CompAction::CallBack term);
        void optionSetSelectSingleKeyNotify (ChangeNotify notify);

        CompAction & optionGetGroupKey ();
        void optionSetGroupKeyInitiate (CompAction::CallBack init);
        void optionSetGroupKeyTerminate (CompAction::CallBack term);
        void optionSetGroupKeyNotify (ChangeNotify notify);

        CompAction & optionGetUngroupKey ();
        void optionSetUngroupKeyInitiate (CompAction::CallBack init);
        void optionSetUngroupKeyTerminate (CompAction::CallBack term);
        void optionSetUngroupKeyNotify (ChangeNotify notify);

        CompAction & optionGetRemoveKey ();
        void optionSetRemoveKeyInitiate (CompAction::CallBack init);
        void optionSetRemoveKeyTerminate (CompAction::CallBack term);
        void optionSetRemoveKeyNotify (ChangeNotify notify);

        CompAction & optionGetCloseKey ();
        void optionSetCloseKeyInitiate (CompAction::CallBack init);
        void optionSetCloseKeyTerminate (CompAction::CallBack term);
        void optionSetCloseKeyNotify (ChangeNotify notify);

        CompAction & optionGetIgnoreKey ();
        void optionSetIgnoreKeyInitiate (CompAction::CallBack init);
        void optionSetIgnoreKeyTerminate (CompAction::CallBack term);
        void optionSetIgnoreKeyNotify (ChangeNotify notify);

        CompAction & optionGetTabmodeKey ();
        void optionSetTabmodeKeyInitiate (CompAction::CallBack init);
        void optionSetTabmodeKeyTerminate (CompAction::CallBack term);
        void optionSetTabmodeKeyNotify (ChangeNotify notify);

        CompAction & optionGetChangeTabLeftKey ();
        void optionSetChangeTabLeftKeyInitiate (CompAction::CallBack init);
        void optionSetChangeTabLeftKeyTerminate (CompAction::CallBack term);
        void optionSetChangeTabLeftKeyNotify (ChangeNotify notify);

        CompAction & optionGetChangeTabRightKey ();
        void optionSetChangeTabRightKeyInitiate (CompAction::CallBack init);
        void optionSetChangeTabRightKeyTerminate (CompAction::CallBack term);
        void optionSetChangeTabRightKeyNotify (ChangeNotify notify);

        CompAction & optionGetChangeColorKey ();
        void optionSetChangeColorKeyInitiate (CompAction::CallBack init);
        void optionSetChangeColorKeyTerminate (CompAction::CallBack term);
        void optionSetChangeColorKeyNotify (ChangeNotify notify);

        bool optionGetMoveAll ();
        void optionSetMoveAllNotify (ChangeNotify notify);

        bool optionGetResizeAll ();
        void optionSetResizeAllNotify (ChangeNotify notify);

        bool optionGetRaiseAll ();
        void optionSetRaiseAllNotify (ChangeNotify notify);

        bool optionGetMaximizeUnmaximizeAll ();
        void optionSetMaximizeUnmaximizeAllNotify (ChangeNotify notify);

        bool optionGetMinimizeAll ();
        void optionSetMinimizeAllNotify (ChangeNotify notify);

        bool optionGetShadeAll ();
        void optionSetShadeAllNotify (ChangeNotify notify);

        bool optionGetAutoGroup ();
        void optionSetAutoGroupNotify (ChangeNotify notify);

        bool optionGetAutoUngroup ();
        void optionSetAutoUngroupNotify (ChangeNotify notify);

        CompMatch & optionGetWindowMatch ();
        void optionSetWindowMatchNotify (ChangeNotify notify);

        int optionGetSelectOpacity ();
        void optionSetSelectOpacityNotify (ChangeNotify notify);

        int optionGetSelectSaturation ();
        void optionSetSelectSaturationNotify (ChangeNotify notify);

        int optionGetSelectBrightness ();
        void optionSetSelectBrightnessNotify (ChangeNotify notify);

        int optionGetSelectPrecision ();
        void optionSetSelectPrecisionNotify (ChangeNotify notify);

        unsigned short * optionGetFillColor ();
        unsigned short optionGetFillColorRed ();
        unsigned short optionGetFillColorGreen ();
        unsigned short optionGetFillColorBlue ();
        unsigned short optionGetFillColorAlpha ();
        void optionSetFillColorNotify (ChangeNotify notify);

        unsigned short * optionGetLineColor ();
        unsigned short optionGetLineColorRed ();
        unsigned short optionGetLineColorGreen ();
        unsigned short optionGetLineColorBlue ();
        unsigned short optionGetLineColorAlpha ();
        void optionSetLineColorNotify (ChangeNotify notify);

        bool optionGetMipmaps ();
        void optionSetMipmapsNotify (ChangeNotify notify);

        bool optionGetUntabOnClose ();
        void optionSetUntabOnCloseNotify (ChangeNotify notify);

        bool optionGetAutotabCreate ();
        void optionSetAutotabCreateNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetAutotabWindows ();
        void optionSetAutotabWindowsNotify (ChangeNotify notify);

        float optionGetTabbarShowDelay ();
        void optionSetTabbarShowDelayNotify (ChangeNotify notify);

        float optionGetTabbingSpeed ();
        void optionSetTabbingSpeedNotify (ChangeNotify notify);

        float optionGetTabbingTimestep ();
        void optionSetTabbingTimestepNotify (ChangeNotify notify);

        float optionGetFadeTime ();
        void optionSetFadeTimeNotify (ChangeNotify notify);

        float optionGetPulseTime ();
        void optionSetPulseTimeNotify (ChangeNotify notify);

        float optionGetReflexTime ();
        void optionSetReflexTimeNotify (ChangeNotify notify);

        float optionGetFadeTextTime ();
        void optionSetFadeTextTimeNotify (ChangeNotify notify);

        float optionGetVisibilityTime ();
        void optionSetVisibilityTimeNotify (ChangeNotify notify);

        float optionGetChangeAnimationTime ();
        void optionSetChangeAnimationTimeNotify (ChangeNotify notify);

        bool optionGetBarAnimations ();
        void optionSetBarAnimationsNotify (ChangeNotify notify);

        int optionGetThumbSize ();
        void optionSetThumbSizeNotify (ChangeNotify notify);

        int optionGetThumbSpace ();
        void optionSetThumbSpaceNotify (ChangeNotify notify);

        int optionGetBorderRadius ();
        void optionSetBorderRadiusNotify (ChangeNotify notify);

        int optionGetBorderWidth ();
        void optionSetBorderWidthNotify (ChangeNotify notify);

        unsigned short * optionGetTabBaseColor ();
        unsigned short optionGetTabBaseColorRed ();
        unsigned short optionGetTabBaseColorGreen ();
        unsigned short optionGetTabBaseColorBlue ();
        unsigned short optionGetTabBaseColorAlpha ();
        void optionSetTabBaseColorNotify (ChangeNotify notify);

        unsigned short * optionGetTabBorderColor ();
        unsigned short optionGetTabBorderColorRed ();
        unsigned short optionGetTabBorderColorGreen ();
        unsigned short optionGetTabBorderColorBlue ();
        unsigned short optionGetTabBorderColorAlpha ();
        void optionSetTabBorderColorNotify (ChangeNotify notify);

        unsigned short * optionGetTabHighlightColor ();
        unsigned short optionGetTabHighlightColorRed ();
        unsigned short optionGetTabHighlightColorGreen ();
        unsigned short optionGetTabHighlightColorBlue ();
        unsigned short optionGetTabHighlightColorAlpha ();
        void optionSetTabHighlightColorNotify (ChangeNotify notify);

        int optionGetTabStyle ();
        void optionSetTabStyleNotify (ChangeNotify notify);

        int optionGetTabbarFontSize ();
        void optionSetTabbarFontSizeNotify (ChangeNotify notify);

        unsigned short * optionGetTabbarFontColor ();
        unsigned short optionGetTabbarFontColorRed ();
        unsigned short optionGetTabbarFontColorGreen ();
        unsigned short optionGetTabbarFontColorBlue ();
        unsigned short optionGetTabbarFontColorAlpha ();
        void optionSetTabbarFontColorNotify (ChangeNotify notify);

        bool optionGetDndUngroupWindow ();
        void optionSetDndUngroupWindowNotify (ChangeNotify notify);

        float optionGetDragHoverTime ();
        void optionSetDragHoverTimeNotify (ChangeNotify notify);

        float optionGetDragSpringK ();
        void optionSetDragSpringKNotify (ChangeNotify notify);

        float optionGetDragFriction ();
        void optionSetDragFrictionNotify (ChangeNotify notify);

        int optionGetDragYDistance ();
        void optionSetDragYDistanceNotify (ChangeNotify notify);

        int optionGetDragSpeedLimit ();
        void optionSetDragSpeedLimitNotify (ChangeNotify notify);

        bool optionGetGlow ();
        void optionSetGlowNotify (ChangeNotify notify);

        int optionGetGlowSize ();
        void optionSetGlowSizeNotify (ChangeNotify notify);

        int optionGetGlowType ();
        void optionSetGlowTypeNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
GroupOptions::optionGetSelectButton ()
{
    return mOptions[GroupOptions::SelectButton].value ().action ();
}

inline void
GroupOptions::optionSetSelectButtonInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::SelectButton].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetSelectButtonTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::SelectButton].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetSelectButtonNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::SelectButton] = notify;
}

inline CompAction &
GroupOptions::optionGetSelectSingleKey ()
{
    return mOptions[GroupOptions::SelectSingleKey].value ().action ();
}

inline void
GroupOptions::optionSetSelectSingleKeyInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::SelectSingleKey].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetSelectSingleKeyTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::SelectSingleKey].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetSelectSingleKeyNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::SelectSingleKey] = notify;
}

inline CompAction &
GroupOptions::optionGetGroupKey ()
{
    return mOptions[GroupOptions::GroupKey].value ().action ();
}

inline void
GroupOptions::optionSetGroupKeyInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::GroupKey].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetGroupKeyTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::GroupKey].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetGroupKeyNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::GroupKey] = notify;
}

inline CompAction &
GroupOptions::optionGetUngroupKey ()
{
    return mOptions[GroupOptions::UngroupKey].value ().action ();
}

inline void
GroupOptions::optionSetUngroupKeyInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::UngroupKey].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetUngroupKeyTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::UngroupKey].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetUngroupKeyNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::UngroupKey] = notify;
}

inline CompAction &
GroupOptions::optionGetRemoveKey ()
{
    return mOptions[GroupOptions::RemoveKey].value ().action ();
}

inline void
GroupOptions::optionSetRemoveKeyInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::RemoveKey].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetRemoveKeyTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::RemoveKey].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetRemoveKeyNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::RemoveKey] = notify;
}

inline CompAction &
GroupOptions::optionGetCloseKey ()
{
    return mOptions[GroupOptions::CloseKey].value ().action ();
}

inline void
GroupOptions::optionSetCloseKeyInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::CloseKey].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetCloseKeyTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::CloseKey].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetCloseKeyNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::CloseKey] = notify;
}

inline CompAction &
GroupOptions::optionGetIgnoreKey ()
{
    return mOptions[GroupOptions::IgnoreKey].value ().action ();
}

inline void
GroupOptions::optionSetIgnoreKeyInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::IgnoreKey].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetIgnoreKeyTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::IgnoreKey].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetIgnoreKeyNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::IgnoreKey] = notify;
}

inline CompAction &
GroupOptions::optionGetTabmodeKey ()
{
    return mOptions[GroupOptions::TabmodeKey].value ().action ();
}

inline void
GroupOptions::optionSetTabmodeKeyInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::TabmodeKey].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetTabmodeKeyTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::TabmodeKey].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetTabmodeKeyNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::TabmodeKey] = notify;
}

inline CompAction &
GroupOptions::optionGetChangeTabLeftKey ()
{
    return mOptions[GroupOptions::ChangeTabLeftKey].value ().action ();
}

inline void
GroupOptions::optionSetChangeTabLeftKeyInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::ChangeTabLeftKey].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetChangeTabLeftKeyTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::ChangeTabLeftKey].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetChangeTabLeftKeyNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::ChangeTabLeftKey] = notify;
}

inline CompAction &
GroupOptions::optionGetChangeTabRightKey ()
{
    return mOptions[GroupOptions::ChangeTabRightKey].value ().action ();
}

inline void
GroupOptions::optionSetChangeTabRightKeyInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::ChangeTabRightKey].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetChangeTabRightKeyTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::ChangeTabRightKey].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetChangeTabRightKeyNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::ChangeTabRightKey] = notify;
}

inline CompAction &
GroupOptions::optionGetChangeColorKey ()
{
    return mOptions[GroupOptions::ChangeColorKey].value ().action ();
}

inline void
GroupOptions::optionSetChangeColorKeyInitiate (CompAction::CallBack init)
{
    mOptions[GroupOptions::ChangeColorKey].value ().action ().setInitiate (init);
}

inline void
GroupOptions::optionSetChangeColorKeyTerminate (CompAction::CallBack term)
{
    mOptions[GroupOptions::ChangeColorKey].value ().action ().setTerminate (term);
}

inline void
GroupOptions::optionSetChangeColorKeyNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::ChangeColorKey] = notify;
}

inline bool
GroupOptions::optionGetMoveAll ()
{
    return mOptions[GroupOptions::MoveAll].value ().b ();
}

inline void
GroupOptions::optionSetMoveAllNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::MoveAll] = notify;
}

inline bool
GroupOptions::optionGetResizeAll ()
{
    return mOptions[GroupOptions::ResizeAll].value ().b ();
}

inline void
GroupOptions::optionSetResizeAllNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::ResizeAll] = notify;
}

inline bool
GroupOptions::optionGetRaiseAll ()
{
    return mOptions[GroupOptions::RaiseAll].value ().b ();
}

inline void
GroupOptions::optionSetRaiseAllNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::RaiseAll] = notify;
}

inline bool
GroupOptions::optionGetMaximizeUnmaximizeAll ()
{
    return mOptions[GroupOptions::MaximizeUnmaximizeAll].value ().b ();
}

inline void
GroupOptions::optionSetMaximizeUnmaximizeAllNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::MaximizeUnmaximizeAll] = notify;
}

inline bool
GroupOptions::optionGetMinimizeAll ()
{
    return mOptions[GroupOptions::MinimizeAll].value ().b ();
}

inline void
GroupOptions::optionSetMinimizeAllNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::MinimizeAll] = notify;
}

inline bool
GroupOptions::optionGetShadeAll ()
{
    return mOptions[GroupOptions::ShadeAll].value ().b ();
}

inline void
GroupOptions::optionSetShadeAllNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::ShadeAll] = notify;
}

inline bool
GroupOptions::optionGetAutoGroup ()
{
    return mOptions[GroupOptions::AutoGroup].value ().b ();
}

inline void
GroupOptions::optionSetAutoGroupNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::AutoGroup] = notify;
}

inline bool
GroupOptions::optionGetAutoUngroup ()
{
    return mOptions[GroupOptions::AutoUngroup].value ().b ();
}

inline void
GroupOptions::optionSetAutoUngroupNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::AutoUngroup] = notify;
}

inline CompMatch &
GroupOptions::optionGetWindowMatch ()
{
    return mOptions[GroupOptions::WindowMatch].value ().match ();
}

inline void
GroupOptions::optionSetWindowMatchNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::WindowMatch] = notify;
}

inline int
GroupOptions::optionGetSelectOpacity ()
{
    return mOptions[GroupOptions::SelectOpacity].value ().i ();
}

inline void
GroupOptions::optionSetSelectOpacityNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::SelectOpacity] = notify;
}

inline int
GroupOptions::optionGetSelectSaturation ()
{
    return mOptions[GroupOptions::SelectSaturation].value ().i ();
}

inline void
GroupOptions::optionSetSelectSaturationNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::SelectSaturation] = notify;
}

inline int
GroupOptions::optionGetSelectBrightness ()
{
    return mOptions[GroupOptions::SelectBrightness].value ().i ();
}

inline void
GroupOptions::optionSetSelectBrightnessNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::SelectBrightness] = notify;
}

inline int
GroupOptions::optionGetSelectPrecision ()
{
    return mOptions[GroupOptions::SelectPrecision].value ().i ();
}

inline void
GroupOptions::optionSetSelectPrecisionNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::SelectPrecision] = notify;
}

inline unsigned short *
GroupOptions::optionGetFillColor ()
{
    return mOptions[GroupOptions::FillColor].value ().c ();
}

inline unsigned short
GroupOptions::optionGetFillColorRed ()
{
    return mOptions[GroupOptions::FillColor].value ().c ()[0];
}

inline unsigned short
GroupOptions::optionGetFillColorGreen ()
{
    return mOptions[GroupOptions::FillColor].value ().c ()[1];
}


inline unsigned short
GroupOptions::optionGetFillColorBlue ()
{
    return mOptions[GroupOptions::FillColor].value ().c ()[2];
}


inline unsigned short
GroupOptions::optionGetFillColorAlpha ()
{
    return mOptions[GroupOptions::FillColor].value ().c ()[3];
}


inline void
GroupOptions::optionSetFillColorNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::FillColor] = notify;
}

inline unsigned short *
GroupOptions::optionGetLineColor ()
{
    return mOptions[GroupOptions::LineColor].value ().c ();
}

inline unsigned short
GroupOptions::optionGetLineColorRed ()
{
    return mOptions[GroupOptions::LineColor].value ().c ()[0];
}

inline unsigned short
GroupOptions::optionGetLineColorGreen ()
{
    return mOptions[GroupOptions::LineColor].value ().c ()[1];
}


inline unsigned short
GroupOptions::optionGetLineColorBlue ()
{
    return mOptions[GroupOptions::LineColor].value ().c ()[2];
}


inline unsigned short
GroupOptions::optionGetLineColorAlpha ()
{
    return mOptions[GroupOptions::LineColor].value ().c ()[3];
}


inline void
GroupOptions::optionSetLineColorNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::LineColor] = notify;
}

inline bool
GroupOptions::optionGetMipmaps ()
{
    return mOptions[GroupOptions::Mipmaps].value ().b ();
}

inline void
GroupOptions::optionSetMipmapsNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::Mipmaps] = notify;
}

inline bool
GroupOptions::optionGetUntabOnClose ()
{
    return mOptions[GroupOptions::UntabOnClose].value ().b ();
}

inline void
GroupOptions::optionSetUntabOnCloseNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::UntabOnClose] = notify;
}

inline bool
GroupOptions::optionGetAutotabCreate ()
{
    return mOptions[GroupOptions::AutotabCreate].value ().b ();
}

inline void
GroupOptions::optionSetAutotabCreateNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::AutotabCreate] = notify;
}

inline CompOption::Value::Vector &
GroupOptions::optionGetAutotabWindows ()
{
    return mOptions[GroupOptions::AutotabWindows].value ().list ();
}

inline void
GroupOptions::optionSetAutotabWindowsNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::AutotabWindows] = notify;
}

inline float
GroupOptions::optionGetTabbarShowDelay ()
{
    return mOptions[GroupOptions::TabbarShowDelay].value ().f ();
}

inline void
GroupOptions::optionSetTabbarShowDelayNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::TabbarShowDelay] = notify;
}

inline float
GroupOptions::optionGetTabbingSpeed ()
{
    return mOptions[GroupOptions::TabbingSpeed].value ().f ();
}

inline void
GroupOptions::optionSetTabbingSpeedNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::TabbingSpeed] = notify;
}

inline float
GroupOptions::optionGetTabbingTimestep ()
{
    return mOptions[GroupOptions::TabbingTimestep].value ().f ();
}

inline void
GroupOptions::optionSetTabbingTimestepNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::TabbingTimestep] = notify;
}

inline float
GroupOptions::optionGetFadeTime ()
{
    return mOptions[GroupOptions::FadeTime].value ().f ();
}

inline void
GroupOptions::optionSetFadeTimeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::FadeTime] = notify;
}

inline float
GroupOptions::optionGetPulseTime ()
{
    return mOptions[GroupOptions::PulseTime].value ().f ();
}

inline void
GroupOptions::optionSetPulseTimeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::PulseTime] = notify;
}

inline float
GroupOptions::optionGetReflexTime ()
{
    return mOptions[GroupOptions::ReflexTime].value ().f ();
}

inline void
GroupOptions::optionSetReflexTimeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::ReflexTime] = notify;
}

inline float
GroupOptions::optionGetFadeTextTime ()
{
    return mOptions[GroupOptions::FadeTextTime].value ().f ();
}

inline void
GroupOptions::optionSetFadeTextTimeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::FadeTextTime] = notify;
}

inline float
GroupOptions::optionGetVisibilityTime ()
{
    return mOptions[GroupOptions::VisibilityTime].value ().f ();
}

inline void
GroupOptions::optionSetVisibilityTimeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::VisibilityTime] = notify;
}

inline float
GroupOptions::optionGetChangeAnimationTime ()
{
    return mOptions[GroupOptions::ChangeAnimationTime].value ().f ();
}

inline void
GroupOptions::optionSetChangeAnimationTimeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::ChangeAnimationTime] = notify;
}

inline bool
GroupOptions::optionGetBarAnimations ()
{
    return mOptions[GroupOptions::BarAnimations].value ().b ();
}

inline void
GroupOptions::optionSetBarAnimationsNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::BarAnimations] = notify;
}

inline int
GroupOptions::optionGetThumbSize ()
{
    return mOptions[GroupOptions::ThumbSize].value ().i ();
}

inline void
GroupOptions::optionSetThumbSizeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::ThumbSize] = notify;
}

inline int
GroupOptions::optionGetThumbSpace ()
{
    return mOptions[GroupOptions::ThumbSpace].value ().i ();
}

inline void
GroupOptions::optionSetThumbSpaceNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::ThumbSpace] = notify;
}

inline int
GroupOptions::optionGetBorderRadius ()
{
    return mOptions[GroupOptions::BorderRadius].value ().i ();
}

inline void
GroupOptions::optionSetBorderRadiusNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::BorderRadius] = notify;
}

inline int
GroupOptions::optionGetBorderWidth ()
{
    return mOptions[GroupOptions::BorderWidth].value ().i ();
}

inline void
GroupOptions::optionSetBorderWidthNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::BorderWidth] = notify;
}

inline unsigned short *
GroupOptions::optionGetTabBaseColor ()
{
    return mOptions[GroupOptions::TabBaseColor].value ().c ();
}

inline unsigned short
GroupOptions::optionGetTabBaseColorRed ()
{
    return mOptions[GroupOptions::TabBaseColor].value ().c ()[0];
}

inline unsigned short
GroupOptions::optionGetTabBaseColorGreen ()
{
    return mOptions[GroupOptions::TabBaseColor].value ().c ()[1];
}


inline unsigned short
GroupOptions::optionGetTabBaseColorBlue ()
{
    return mOptions[GroupOptions::TabBaseColor].value ().c ()[2];
}


inline unsigned short
GroupOptions::optionGetTabBaseColorAlpha ()
{
    return mOptions[GroupOptions::TabBaseColor].value ().c ()[3];
}


inline void
GroupOptions::optionSetTabBaseColorNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::TabBaseColor] = notify;
}

inline unsigned short *
GroupOptions::optionGetTabBorderColor ()
{
    return mOptions[GroupOptions::TabBorderColor].value ().c ();
}

inline unsigned short
GroupOptions::optionGetTabBorderColorRed ()
{
    return mOptions[GroupOptions::TabBorderColor].value ().c ()[0];
}

inline unsigned short
GroupOptions::optionGetTabBorderColorGreen ()
{
    return mOptions[GroupOptions::TabBorderColor].value ().c ()[1];
}


inline unsigned short
GroupOptions::optionGetTabBorderColorBlue ()
{
    return mOptions[GroupOptions::TabBorderColor].value ().c ()[2];
}


inline unsigned short
GroupOptions::optionGetTabBorderColorAlpha ()
{
    return mOptions[GroupOptions::TabBorderColor].value ().c ()[3];
}


inline void
GroupOptions::optionSetTabBorderColorNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::TabBorderColor] = notify;
}

inline unsigned short *
GroupOptions::optionGetTabHighlightColor ()
{
    return mOptions[GroupOptions::TabHighlightColor].value ().c ();
}

inline unsigned short
GroupOptions::optionGetTabHighlightColorRed ()
{
    return mOptions[GroupOptions::TabHighlightColor].value ().c ()[0];
}

inline unsigned short
GroupOptions::optionGetTabHighlightColorGreen ()
{
    return mOptions[GroupOptions::TabHighlightColor].value ().c ()[1];
}


inline unsigned short
GroupOptions::optionGetTabHighlightColorBlue ()
{
    return mOptions[GroupOptions::TabHighlightColor].value ().c ()[2];
}


inline unsigned short
GroupOptions::optionGetTabHighlightColorAlpha ()
{
    return mOptions[GroupOptions::TabHighlightColor].value ().c ()[3];
}


inline void
GroupOptions::optionSetTabHighlightColorNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::TabHighlightColor] = notify;
}

inline int
GroupOptions::optionGetTabStyle ()
{
    return mOptions[GroupOptions::TabStyle].value ().i ();
}

inline void
GroupOptions::optionSetTabStyleNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::TabStyle] = notify;
}

inline int
GroupOptions::optionGetTabbarFontSize ()
{
    return mOptions[GroupOptions::TabbarFontSize].value ().i ();
}

inline void
GroupOptions::optionSetTabbarFontSizeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::TabbarFontSize] = notify;
}

inline unsigned short *
GroupOptions::optionGetTabbarFontColor ()
{
    return mOptions[GroupOptions::TabbarFontColor].value ().c ();
}

inline unsigned short
GroupOptions::optionGetTabbarFontColorRed ()
{
    return mOptions[GroupOptions::TabbarFontColor].value ().c ()[0];
}

inline unsigned short
GroupOptions::optionGetTabbarFontColorGreen ()
{
    return mOptions[GroupOptions::TabbarFontColor].value ().c ()[1];
}


inline unsigned short
GroupOptions::optionGetTabbarFontColorBlue ()
{
    return mOptions[GroupOptions::TabbarFontColor].value ().c ()[2];
}


inline unsigned short
GroupOptions::optionGetTabbarFontColorAlpha ()
{
    return mOptions[GroupOptions::TabbarFontColor].value ().c ()[3];
}


inline void
GroupOptions::optionSetTabbarFontColorNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::TabbarFontColor] = notify;
}

inline bool
GroupOptions::optionGetDndUngroupWindow ()
{
    return mOptions[GroupOptions::DndUngroupWindow].value ().b ();
}

inline void
GroupOptions::optionSetDndUngroupWindowNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::DndUngroupWindow] = notify;
}

inline float
GroupOptions::optionGetDragHoverTime ()
{
    return mOptions[GroupOptions::DragHoverTime].value ().f ();
}

inline void
GroupOptions::optionSetDragHoverTimeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::DragHoverTime] = notify;
}

inline float
GroupOptions::optionGetDragSpringK ()
{
    return mOptions[GroupOptions::DragSpringK].value ().f ();
}

inline void
GroupOptions::optionSetDragSpringKNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::DragSpringK] = notify;
}

inline float
GroupOptions::optionGetDragFriction ()
{
    return mOptions[GroupOptions::DragFriction].value ().f ();
}

inline void
GroupOptions::optionSetDragFrictionNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::DragFriction] = notify;
}

inline int
GroupOptions::optionGetDragYDistance ()
{
    return mOptions[GroupOptions::DragYDistance].value ().i ();
}

inline void
GroupOptions::optionSetDragYDistanceNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::DragYDistance] = notify;
}

inline int
GroupOptions::optionGetDragSpeedLimit ()
{
    return mOptions[GroupOptions::DragSpeedLimit].value ().i ();
}

inline void
GroupOptions::optionSetDragSpeedLimitNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::DragSpeedLimit] = notify;
}

inline bool
GroupOptions::optionGetGlow ()
{
    return mOptions[GroupOptions::Glow].value ().b ();
}

inline void
GroupOptions::optionSetGlowNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::Glow] = notify;
}

inline int
GroupOptions::optionGetGlowSize ()
{
    return mOptions[GroupOptions::GlowSize].value ().i ();
}

inline void
GroupOptions::optionSetGlowSizeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::GlowSize] = notify;
}

inline int
GroupOptions::optionGetGlowType ()
{
    return mOptions[GroupOptions::GlowType].value ().i ();
}

inline void
GroupOptions::optionSetGlowTypeNotify (GroupOptions::ChangeNotify notify)
{
    mNotify[GroupOptions::GlowType] = notify;
}



#endif
